#ifndef MSP_GEOMETRY_RECTANGLE_H_
#define MSP_GEOMETRY_RECTANGLE_H_

#include "hyperbox.h"

namespace Msp {
namespace Geometry {

/**
The two-dimensional special case of a HyperBox.  This class exists for
convenience only and does not provide any extra functionality over the base
class.
*/
template<typename T>
class Rectangle: public HyperBox<T, 2>
{
public:
	Rectangle() { }
	explicit Rectangle(const LinAl::Vector<T, 2> &d): HyperBox<T, 2>(d) { }
	Rectangle(T w, T h): HyperBox<T, 2>(LinAl::Vector<T, 2>(w, h)) { }

	T get_width() const { return this->get_dimension(0); }
	T get_height() const { return this->get_dimension(1); }
};

} // namespace Geometry
} // namespace Msp

#endif
